;;Test Nr 13 - Boomerang time script

(if (zero? (- (get-last-sp (who-am-I)) 1))
  (set-last-sp (who-am-I) 2)
)

(define frange (check-invisible-object-inside "Range" (who-am-I)))

(if (not(= (get-direction (who-am-I)) (get-last-grace frange)))
  (set-last-sp (who-am-I) (get-last-sp frange))
)

(define fowner (check-invisible-object-inside "Owner" (who-am-I)))
(define fplayer (find-player (get-script-throw fowner)))

(do
  (
    (fboucle
      (get-first-object-on-square (get-map (who-am-I)) (get-x-position (who-am-I)) (get-y-position (who-am-I)))
      (get-previous-object fboucle)
    )
  )
  ((zero? (get-previous-object fboucle)) ())
  (begin
    (if (not (can-be-picked? fboucle))
      (if (not (invisible? fboucle))
        (if (string=? (get-name fboucle) (get-script-throw fowner))
          ()
          (pick-up fplayer fboucle)
        )
        ()
      )
    )
  )
)

(if
  (>=
    (get-last-sp frange)
    (get-last-sp (who-am-I))
  )
  (begin
    (cond
      ( (< (get-x-position fplayer) (get-x-position (who-am-I)))
        (cond
          ((< (get-y-position fplayer) (get-y-position (who-am-I))) (set-direction (who-am-I) (direction-north-west)))
          ((> (get-y-position fplayer) (get-y-position (who-am-I))) (set-direction (who-am-I) (direction-south-west)))
          ((= (get-y-position fplayer) (get-y-position (who-am-I))) (set-direction (who-am-I) (direction-west)))
        )
      )
      ( (> (get-x-position fplayer) (get-x-position (who-am-I)))
        (cond
          ((< (get-y-position fplayer) (get-y-position (who-am-I))) (set-direction (who-am-I) (direction-north-east)))
          ((> (get-y-position fplayer) (get-y-position (who-am-I))) (set-direction (who-am-I) (direction-south-east)))
          ((= (get-y-position fplayer) (get-y-position (who-am-I))) (set-direction (who-am-I) (direction-east)))
        )
      )
      ( (= (get-x-position fplayer) (get-x-position (who-am-I)))
        (cond
          ((< (get-y-position fplayer) (get-y-position (who-am-I))) (set-direction (who-am-I) (direction-north)))
          ((> (get-y-position fplayer) (get-y-position (who-am-I))) (set-direction (who-am-I) (direction-south)))
          ((= (get-y-position fplayer) (get-y-position (who-am-I)))
            (begin
              (set-last-sp (who-am-I) 0)
              (set-script-time (who-am-I) "")
              (kill-object (who-am-I) fowner 0)
              (kill-object (who-am-I) frange 0)
              (pick-up fplayer (who-am-I))
            )
          )
        )
      )
    )
  )
)
(cond
  ( (= (get-direction (who-am-I)) (direction-north))
    (if (out-of-map? (who-am-I) (get-x-position (who-am-I)) (- (get-y-position (who-am-I)) 1))
      (set-direction (who-am-I) (direction-south))
    )
  )
  ( (= (get-direction (who-am-I)) (direction-south))
    (if (out-of-map? (who-am-I) (get-x-position (who-am-I)) (+ (get-y-position (who-am-I)) 1))
      (set-direction (who-am-I) (direction-north))
    )
  )
  ( (= (get-direction (who-am-I)) (direction-west))
    (if (out-of-map? (who-am-I) (- (get-x-position (who-am-I)) 1) (get-y-position (who-am-I)))
      (set-direction (who-am-I) (direction-east))
    )
  )
  ( (= (get-direction (who-am-I)) (direction-east))
    (if (out-of-map? (who-am-I) (+ (get-x-position (who-am-I)) 1) (get-y-position (who-am-I)))
      (set-direction (who-am-I) (direction-west))
    )
  )
  ( (= (get-direction (who-am-I)) (direction-north-east))
    (if (out-of-map? (who-am-I) (+ (get-x-position (who-am-I)) 1) (- (get-y-position (who-am-I)) 1))
      (set-direction (who-am-I) (direction-south-west))
    )
  )
  ( (= (get-direction (who-am-I)) (direction-north-west))
    (if (out-of-map? (who-am-I) (- (get-x-position (who-am-I)) 1) (- (get-y-position (who-am-I)) 1))
      (set-direction (who-am-I) (direction-south-east))
    )
  )
  ( (= (get-direction (who-am-I)) (direction-south-east))
    (if (out-of-map? (who-am-I) (+ (get-x-position (who-am-I)) 1) (+ (get-y-position (who-am-I)) 1))
      (set-direction (who-am-I) (direction-north-west))
    )
  )
  ( (= (get-direction (who-am-I)) (direction-south-west))
    (if (out-of-map? (who-am-I) (- (get-x-position (who-am-I)) 1) (+ (get-y-position (who-am-I)) 1))
      (set-direction (who-am-I) (direction-north-east))
    )
  )
)